
#if !defined(TEMPLATE_H_INCLUDED)
#define TEMPLATE_H_INCLUDED

template<class T>
class CArray {
public:
  CArray();
  CArray(int count);
  CArray(const CArray &source);
  ~CArray();
  CArray& operator=(const CArray &source);
  void Init(int count);
  int Count() { return count; }
  T& operator[](int i);
private:
  T *array;
  int count;
};

template <class T>
CArray<T>::CArray() {
  array = NULL;
  count = 0;
}

template <class T>
CArray<T>::CArray(int count) {
  array = NULL;
  Init(count);
}

template <class T>
CArray<T>::CArray(const CArray<T> &source) {
  array = NULL;
  *this = source;
}

template <class T>
CArray<T>::~CArray() {
  if (array) { delete array; array = NULL; }
}

template <class T>
CArray<T>& CArray<T>::operator=(const CArray<T> &source) {
  if (array) delete array;
  count = source.count;
  if (source.array) {
    array = new T[count];
    for (int i=0; i<count; i++) array[i] = source.array[i];
  }
  else {
    array = NULL;
  }
  return *this;
}

template <class T>
void CArray<T>::Init(int count) {
  if (array) delete array;
  this->count = count;
  array = new T[count];
}

template <class T>
T& CArray<T>::operator[](int i) {
  return array[i];
}

#endif
